#!/bin/bash
#
# mkstatsnetrrd.sh - Creates the original RRD database needed.
# Copyright (C) 2002 Oskar Andreasson
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#

if [ -f $HOME/.statsnetrc ]; then
        . $HOME/.statsnetrc
elif [ -f /etc/statsnet.conf ]; then
        . /etc/statsnet.conf
else
        echo "No config files\!"
        return 0
fi

MXTIME=$(($INTERVAL + 2))

mkdir -p `dirname $DATAFILE`
mkdir -p $OUTDIR

rrdtool create $DATAFILE --step $INTERVAL \
        DS:tx_bytes:GAUGE:$MXTIME:U:U \
        DS:tx_pkts:GAUGE:$MXTIME:U:U \
        DS:rx_bytes:GAUGE:$MXTIME:U:U \
        DS:rx_pkts:GAUGE:$MXTIME:U:U \
        DS:connections:GAUGE:$MXTIME:U:U \
                RRA:AVERAGE:0.5:1:1440 \
                RRA:AVERAGE:0.5:24:60 \
                RRA:AVERAGE:0.5:30:336 \
		RRA:AVERAGE:0.5:100:3024
