#!/bin/bash
#
# statsnet.sh - A small script to output total sent bytes and packets for NIC's.
# Copyright (C) 2002 Oskar Andreasson
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#

#
# Config options.
#

if [ -f $HOME/.statsnetrc ]; then
	. $HOME/.statsnetrc
elif [ -f /etc/statsnet.conf ]; then
	. /etc/statsnet.conf
else
	echo "No config files\!"
	exit
fi

#
# Initialize variables, so we have something to compare with.
#

RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 2`
CONNECTIONS=`cat /proc/net/ip_conntrack |wc -l`

if [ $RX_BYTES == "${IF}:" ]; then
	RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 3`
	TX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 11`
	TX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 12`
	RX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 4`
else
	RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 2 |cut -d ":" -f 2`
	TX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 10`
	TX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 11`
	RX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 3`
fi

TIMER=0

#
# Empty and erase statistics file when we restart, so we don't mix data.
#
# rm -f $DATAFILE

while [ 1 -eq 1 ]; do
	OLD_TX_BYTES=$TX_BYTES
	OLD_TX_PKTS=$TX_PKTS
	OLD_RX_BYTES=$RX_BYTES
	OLD_RX_PKTS=$RX_PKTS
	OLD_CONNECTIONS=$CONNECTIONS
	TIMER=$(($TIMER + 1))

	RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 2`
	CONNECTIONS=`cat /proc/net/ip_conntrack |wc -l|tr -d " "`

	if [ $RX_BYTES == "${IF}:" ]; then
		RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 3`
		TX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 11`
		TX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 12`
		RX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 4`
	else
		RX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 2 |cut -d ":" -f 2`
		TX_BYTES=`cat $FILE |grep $IF | tr -s " "|cut -d " " -f 10`
		TX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 11`
		RX_PKTS=`cat $FILE |grep $IF | tr -s ' '|cut -d ' ' -f 3`
	fi

	DIFF_TX_BYTES=$(($TX_BYTES - $OLD_TX_BYTES))
	DIFF_TX_PKTS=$(($TX_PKTS - $OLD_TX_PKTS))
	DIFF_RX_BYTES=$(($RX_BYTES - $OLD_RX_BYTES))
	DIFF_RX_PKTS=$(($RX_PKTS - $OLD_RX_PKTS))

	if [ $DIFF_TX_BYTES -lt 0 ]; then
		DIFF_TX_BYTES=0
	fi

	if [ $DIFF_TX_PKTS -lt 0 ]; then
		DIFF_TX_PKTS=0
	fi

	if [ $DIFF_RX_BYTES -lt 0 ]; then
		DIFF_RX_BYTES=0
	fi

	if [ $DIFF_TX_PKTS -lt 0 ]; then
		DIFF_RX_PKTS=0
	fi

	${RRDTOOL} update $DATAFILE \
		N:$DIFF_TX_BYTES:$DIFF_TX_PKTS:$DIFF_RX_BYTES:$DIFF_RX_PKTS:$CONNECTIONS

	if [ $TIMER -eq $UPDATE ]; then
		graphgen.sh &
		TIMER=0
	fi

	sleep $INTERVAL

done
